`timescale 1ns / 1ps

////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer:
//
// Create Date:   17:05:35 06/15/2014
// Design Name:   AES_Comp_DEC_Serial
// Module Name:   D:/Workspace/Verilog/DRECON_AES_DEC/DRECON_AES/test_DRECON_DEC.v
// Project Name:  DRECON_AES
// Target Device:  
// Tool versions:  
// Description: 
//
// Verilog Test Fixture created by ISE for module: AES_Comp_DEC_Serial
//
// Dependencies:
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
////////////////////////////////////////////////////////////////////////////////

module test_DRECON_DEC;

	// Inputs
	reg [127:0] Kin;
	reg [127:0] Din;
	reg [127:0] Tin;
	reg Krdy;
	reg Drdy;
	reg RSTn;
	reg EN;
	reg CLK;

	// Outputs
	wire [127:0] Dout;
	wire BSY;
	wire Kvld;
	wire Dvld;
//	wire [15:0] sin;
//	wire [31:0] kt;
//	wire [31:0] rin;
//	wire [31:0] rnext;
//	wire [31:0] tknext;
//	wire [127:0] dnext;
//	wire [127:0] knext;
//	wire [127:0] krgx;
//	wire [127:0] Tout;
//	wire [32:0] dcount;
//	wire [4:0] kcount;
//	wire [7:0] sout;
//	wire [10:0] rrg;
//	wire [15:0] isin;
//	wire [7:0] isout;

	// Instantiate the Unit Under Test (UUT)
	AES_Comp_DEC_Serial uut (
		.Kin(Kin), 
		.Din(Din), 
		.Tin(Tin), 
		.Dout(Dout), 
		.Krdy(Krdy), 
		.Drdy(Drdy), 
		.RSTn(RSTn), 
		.EN(EN), 
		.CLK(CLK), 
		.BSY(BSY), 
		.Kvld(Kvld), 
		.Dvld(Dvld)
	);

	initial begin
		// Initialize Inputs
		Kin = 0;
		Din = 0;
		Tin = 0;
		Krdy = 0;
		Drdy = 0;
		RSTn = 0;
		EN = 0;
		CLK = 0;

		// Wait 100 ns for global reset to finish
		#200;
		
		RSTn = 1;
		EN = 1;
		Kin = 128'h000102030405060708090A0B0C0D0E0F;
		Tin = 128'h0000000000000000000000000000abc7;
		Krdy = 1;
		
		#200
		
		Krdy = 0;
	end

	initial
		forever #100 CLK <= ~CLK;
		
	always @(negedge CLK) begin
		if ((Kvld == 1) && (BSY == 0) && (Dvld == 0)) begin
			Din <= 128'h7EF8D41360B82FA085F2FFB04E3FBDC5;
			Drdy <= 1;
		end
		else if ((Kvld == 1) && (Dvld == 1)) begin
			Din <= 128'hEAF9572C009AB6B9C31FB88FBB5721C2;
			Drdy <= 1;
		end
	end
	
	always @(posedge CLK) begin
		if (Drdy == 1) begin
			Drdy <= 0;
		end
	end
      
endmodule

