`timescale 1ns / 1ps

////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer:
//
// Create Date:   11:33:14 06/08/2014
// Design Name:   AES_Comp_ENC_Serial
// Module Name:   D:/Workspace/Verilog/DRECON_AES_WORKING/DRECON_AES/test_DRECON.v
// Project Name:  DRECON_AES
// Target Device:  
// Tool versions:  
// Description: 
//
// Verilog Test Fixture created by ISE for module: AES_Comp_ENC_Serial
//
// Dependencies:
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
////////////////////////////////////////////////////////////////////////////////

module test_DRECON;

	// Inputs
	reg [127:0] Kin;
	reg [127:0] Din;
	reg [127:0] Tin;
	reg Krdy;
	reg Drdy;
	reg RSTn;
	reg EN;
	reg CLK;

	// Outputs
	wire [127:0] Dout;
	wire BSY;
	wire Kvld;
	wire Dvld;
	
	wire [15:0] sin;
   wire [31:0] kt;
   wire [31:0] rin;
   wire [31:0] rnext;
   wire [31:0] tknext;
   wire [127:0] dnext;
   wire [127:0] knext;
   wire [40:0] count;
	wire [127:0] krgx;
	wire [127:0] Tout;
	wire [8:0] cc;

	// Instantiate the Unit Under Test (UUT)
	AES_Comp_ENC_Serial uut (
		.Kin(Kin), 
		.Din(Din), 
		.Tin(Tin),
		.Dout(Dout), 
		.Krdy(Krdy), 
		.Drdy(Drdy), 
		.RSTn(RSTn), 
		.EN(EN), 
		.CLK(CLK), 
		.BSY(BSY), 
		.Kvld(Kvld), 
		.Dvld(Dvld), 
		.sin(sin),
		.kt(kt), 
		.rin(rin), 
		.rnext(rnext), 
		.tknext(tknext), 
		.dnext(dnext), 
		.knext(knext), 
		.krgx(krgx),
		.count(count),
		.Tout(Tout),
		.cc(cc)
	);

	initial begin
		// Initialize Inputs
		Kin = 0;
		Din = 0;
		Krdy = 0;
		Drdy = 0;
		RSTn = 0;
		EN = 0;
		CLK = 0;

		// Wait 100 ns for global reset to finish
		#200
		
		RSTn = 1;
		EN = 1;
		Kin = 128'h000102030405060708090A0B0C0D0E0F;
		Tin = 128'habc7;
		Krdy = 1;
		
		#200
		
		Krdy = 0;
		Din = 128'hC1A8E9B2411A914DF5DC918442F4C92B;
		//Dout = 128'h7B913E92B7479169CC496C48AA9F6324

		Drdy = 1;
		
		#200
		
		Drdy = 0;
  
		// Add stimulus here

	end

	initial
		forever #100 CLK <= ~CLK;
		
	always @(negedge CLK) begin
		if (Dvld == 1) begin
			Din  <= 128'hC1A8E9B2411A914DF5DC918442F4C92B;
			Drdy <= 1;
		end
//		if (Drdy == 1) begin
//			Drdy <= 0;
//		end
	end
	
	always @(posedge CLK) begin
		if (Drdy == 1) begin
			Drdy <= 0;
		end
	end
 
      
endmodule

